Subject: draft-ietf-ospf-iana-00

From: Tom Petch <[email-masked]>
Date: Mon, 4 Apr 2005 17:46:09 +0200

I am curious about  the choice of four octet for enterprise code in 2.5.

When used in SNMP, these codes have no effective limit on length; four octet
does seem massive compared to current use (just like the four octet limit of IP
address did a few years ago:-)

I wonder if it is worth a comment in the I-D that this is imposing a limit not
present in the IANA registratoin, albeit one that hopefully will last some time.

Tom Petch

---

From: Kireeti Kompella <[email-masked]>
Date: Mon, 4 Apr 2005 15:07:56 -0700

On Mon, 4 Apr 2005, Tom Petch wrote:

> When used in SNMP, these codes have no effective limit on length;

I was under the impression that each number in an OID sequence was a
32-bit number.  Is that not right?  If so, the first enterprise with
an enterprise ID >= 2^32 would have more serious problems than not
being able to use OSPF Private Use spaces, assuming SNMP is still
around at that time.

> four octet does seem massive compared to current use (just like the
> four octet limit of IP address did a few years ago:-)

The first two billion (or four billion) enterprises will be able to
use the Private Space; the rest ... well, too bad.  Hmmm.  I wonder if
IANA will give me a /8 chunk of enterprise number space ...

> I wonder if it is worth a comment in the I-D that this is imposing a
> limit not present in the IANA registratoin, albeit one that
> hopefully will last some time.

I'm not against that, although the answer above may address this.  On
the other hand, if an OID can only take four octet numbers, either
IANA or RFC 2578 should state the issues that enterprises with numbers
>= 2^32 will face.

Kireeti.
-------

---

From: Tom Petch <[email-masked]>
Date: Tue, 5 Apr 2005 20:06:16 +0200

<inline>
Tom Petch
----- Original Message -----
From: "Kireeti Kompella" <[email-masked]>
To: <[email-masked]>
Sent: Tuesday, April 05, 2005 12:07 AM
Subject: Re: draft-ietf-ospf-iana-00

> 32-bit number.  Is that not right?

Not so.  BER.1 encodes the sub-identifiers of an OID (after the first two) in
what I think of as CCITT encoding, using 7 bits per octet with the other bit as
a flag to say this is (or is not) the last octet.  So a 7 bit sub-identifier
encodes in one octet, 14 bit in two and so on.

I have never seen any other limit imposed and - knowing ISO - I would not expect
there to be one (apart from the overall limit on length of a TLV which is
2**1008 octet - this is ISO:-).

<snip>

---

From: Kireeti Kompella <[email-masked]>
Date: Tue, 5 Apr 2005 14:23:37 -0700

On Tue, 5 Apr 2005, Tom Petch wrote:

> Not so.  BER.1 encodes the sub-identifiers of an OID (after the
> first two) in what I think of as CCITT encoding, using 7 bits per
> octet with the other bit as a flag to say this is (or is not) the
> last octet.  So a 7 bit sub-identifier encodes in one octet, 14 bit
> in two and so on.

Yeesh!  Thanks for the info -- I would never have guessed.

> I have never seen any other limit imposed and - knowing ISO - I

Oh, well.  Does anyone care?

Where were you when I wrote what became RFC 3936 (see section 2, para 3)?

> would not expect there to be one (apart from the overall limit on
> length of a TLV which is 2**1008 octet - this is ISO:-).

If every atom could encode one octet, how many galaxies would that be?
:-)

Kireeti.
-------

---

From: John Flick <[email-masked]>
Date: Tue, 5 Apr 2005 20:04:11 -0700

Actually, this information is true for ISO ASN.1, but not for SNMP.
SNMP's SMI is an "adapted subset" of ASN.1.  That subset is defined
in RFCs 2578-2580.

 From RFC 2578, section 3.5:

    An OBJECT IDENTIFIER value is an ordered list of non-negative
    numbers.  For the SMIv2, each number in the list is referred to as a
    sub-identifier, there are at most 128 sub-identifiers in a value, and
    each sub-identifier has a maximum value of 232-1 (4294967295
    decimal).

I don't believe we have run into any problems with these limits in
SNMP :-) .

So, I don't believe that draft-ietf-ospf-iana draft has a problem here.

John

---

From: Kireeti Kompella <[email-masked]>
Date: Wed, 6 Apr 2005 23:20:57 -0700

> SNMP's SMI is an "adapted subset" of ASN.1.  That subset is defined

You live and learn how little you really know!

>     each sub-identifier has a maximum value of 232-1 (4294967295

Can we now start a thread on whether an OID length of 128 is too
small?  :-)

> So, I don't believe that draft-ietf-ospf-iana draft has a problem here.

Whew!  For a while there, I was worried that we would need 2^128
enterprise codes (and 2^128 enterprises to use them!)  :-)

Kireeti.
-------